<template>
	<el-dialog
		v-model="state.dialogVisible"
		draggable
		title="撤销工单"
		@mouseup="mouseup"
		:style="'transform: ' + state.transform + ';'"
		ref="dialogRef"
		append-to-body
		destroy-on-close
		@close="close"
	>
		<el-form :model="state.ruleForm" label-width="90px" ref="ruleFormRef">
			<el-row :gutter="35">
				<el-col :xs="24" :sm="24" :md="24" :lg="24" :xl="24">
					<el-form-item
						label="撤销说明"
						class="textarea"
						prop="revocationReason"
						:rules="[{ required: true, message: '请填写撤销说明', trigger: 'blur' }]"
					>
						<common-advice
							@chooseAdvice="chooseAdvice"
							v-model="state.ruleForm.revocationReason"
							placeholder="请填写撤销说明"
							:loading="state.loading"
							:commonEnum="commonEnum.OrderCirculation"
						/>
					</el-form-item>
				</el-col>
				<el-col :xs="24" :sm="12" :md="12" :lg="12" :xl="12">
					<el-form-item label="" prop="isSendSms" :rules="[{ required: false, message: '请选择发送撤销短信', trigger: 'change' }]">
						<el-checkbox v-model="state.ruleForm.isSendSms" label="发送撤销短信" />
					</el-form-item>
				</el-col>
			</el-row>
		</el-form>
		<template #footer>
			<span class="dialog-footer">
				<el-button @click="closeDialog" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onSubmit(ruleFormRef)" :loading="state.loading">撤 销</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script setup lang="ts" name="orderRevokeDialog">
import { reactive, ref, defineAsyncComponent } from 'vue';
import { ElMessageBox, ElNotification, FormInstance } from 'element-plus';
import { throttle } from '@/utils/tools';
import { commonEnum } from '@/utils/constants';
import { orderRevoke } from '@/api/business/order';

// 引入组件
const CommonAdvice = defineAsyncComponent(() => import('@/components/CommonAdvice/index.vue')); // 常用意见

// 定义子组件向父组件传值/事件
const emit = defineEmits(['updateList']);
// 定义变量内容
const state = reactive<any>({
	dialogVisible: false,
	ruleForm: {
		revocationReason: null, // 撤销原因
		isSendSms: true, // 是否发送短信
	},
	orderDetail: {}, // 工单详情
	loading: false, // 提交按钮loading
	transform: 'translate(0px, 0px)', // 滚动条位置
});
const ruleFormRef = ref<RefType>();
const ids = ref<EmptyArrayType>([]);
// 打开弹窗
const openDialog = async (val: any) => {
	ids.value = val;
	state.dialogVisible = true;
	state.loading = false;
};
// 关闭弹窗
const closeDialog = () => {
	state.dialogVisible = false;
};
const close = () => {
	ruleFormRef.value?.clearValidate();
	ruleFormRef.value?.resetFields();
};
// 选中常用意见
const chooseAdvice = (item: any) => {
	state.ruleForm.revocationReason += item.content;
};
// 设置抽屉
const dialogRef = ref<RefType>();
const mouseup = () => {
	state.transform = dialogRef.value.dialogContentRef.$el.style.transform;
};
// 提交
const onSubmit = throttle((formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.validate((valid: boolean) => {
		if (!valid) return;
		ElMessageBox.confirm(`您确认要设置撤销?`, '提示', {
			confirmButtonText: '确认',
			cancelButtonText: '取消',
			type: 'warning',
			draggable: true,
			cancelButtonClass: 'default-button',
			autofocus: false,
		})
			.then(() => {
				state.loading = true;
				const request = {
					...state.ruleForm,
					ids: ids.value,
				};
				orderRevoke(request)
					.then((res: any) => {
						ElNotification({
							title: '撤销完成',
							message: `添加撤销成功${res.result.successNum}条，失败${res.result.errorNum}条`,
							type: 'success',
						});
						state.loading = false;
						state.dialogVisible = false;
						emit('updateList');
					})
					.catch(() => {
						state.loading = false;
						state.dialogVisible = false;
					});
			})
			.catch(() => {});
	});
}, 300);
// 暴露变量
defineExpose({
	openDialog,
	closeDialog,
});
</script>
